<!--begin::Portlet-->
<div id="attributes-portlet" class="m-portlet" xmlns="http://www.w3.org/1999/html">
    <div class="m-portlet__head">
        <div class="m-portlet__head-caption">
            <div class="m-portlet__head-title">
                <span class="m-portlet__head-icon m--hide">
                    <i class="la la-gear"></i>
                </span>
                <h3 class="m-portlet__head-text">
                    Add Products To Order
                    <small>Notice: You can only add products that have quantity greater than 0 in any warehouse!</small>
                </h3>
            </div>
        </div>
    </div>

    <form class="m-form m-form--fit m-form--label-align-right m-form--group-seperator-dashed" @submit.prevent="">

        <div class="m-portlet__body">

            <div class="form-group m-form__group row">
                <div class="col-lg-12">
                    <ValidationProvider rules="" v-slot="{ errors }" name="products" ref="products">

                        <label>Products:</label>

                        <autocomplete-input :key="autocompleteKey"
                                            :entity="'products.order'"
                                            @itemSelected="pushToProducts"
                                            :styles="errors.length > 0 ? 'is-invalid form-control m-input' : 'form-control m-input'"
                                            :additionalQueryParams="queryStatus">
                        </autocomplete-input>

                        <div v-if="errors.length > 0" class="invalid-feedback" style="display: inline !important;">
                            {{ errors[0] }}
                        </div>

                        <span v-else class="m-form__help">Please enter product name</span>

                    </ValidationProvider>
                </div>
            </div>
        </div>
    </form>

    <div class="m-portlet__body">
        <!--begin: Datatable -->
        <table class="table table-striped- table-bordered table-hover table-checkable scrollable"
               :style="products.length > 0 ? 'display: block;' : ''">

            <thead>
                <th>
                    Product Image
                </th>
                <th>
                    Name
                </th>
                <th>
                    Variant
                </th>
                <th>
                    Total Price
                </th>
                <th>
                    Quantity
                </th>
                <th v-if="orderStatus == 1">
                    Warehouse
                </th>
                <th>
                    Action
                </th>
            </thead>
            <tbody>

            <tr v-if="products.length < 1">
               <td colspan="7">Order is empty!</td>
            </tr>

            <tr v-for="(product, index) in products">
                <td style="max-width: 100px;">
                    <img :src="getProductImage(product.image)" width="100%" height="100%">
                </td>

                <td>
                    <p>
                        <span class="m--font-primary m--font-boldest">
                            {{ product.name }}
                        </span>
                    </p>
                </td>

                <td>
                    <div class="form-group m-form__group row">
                        <div v-for="(attribute, indexA) in product.attributesValues" :class="'col-lg-' + Math.round(12 / product.attributesValues.length)">
                            <label>{{ attribute.attributeName }}</label>
                            <select class="form-control m-input m-input--air m-input--pill"
                                    v-model="products[index].attributesValues[indexA].valueId"
                                    @change="findProductVariant(index)">
                                <option v-for="(value, indexV) in attribute.values" :value="value.id">{{ value.value }}</option>
                            </select>
                        </div>
                    </div>

                    <ValidationProvider rules="" v-slot="{ errors }" name="product variant" :ref="'products.' + index + '.product_variant_id'">
                        <div v-if="errors.length > 0" class="invalid-feedback" style="display: inline !important;">
                            {{ errors[0] }}
                        </div>
                    </ValidationProvider>
                </td>
                <td style="width: 20%">
                    <ValidationProvider rules="required" v-slot="{ errors }" name="product price" :ref="'products.' + index + '.price'">
                        <div class="m-input-icon m-input-icon--left m-input-icon--right">
                            <input type="number"
                                   min="1"
                                   step="0.01"
                                   v-model="products[index].price"
                                   class="form-control m-input m-input--pill m-input--air"
                                   :class="{ 'is-invalid': errors.length > 0 }"
                                   placeholder="1.00"
                                   :disabled="products[index].attributesValues.find( (el) => el.valueId == null)">
                            <span class="m-input-icon__icon m-input-icon__icon--left">
                                <span>
                                    <i class="la la-dollar"></i>
                                </span>
                            </span>
                        </div>

                        <div v-if="errors.length > 0" class="invalid-feedback" style="display: inline !important;">
                            {{ errors[0] }}
                        </div>
                    </ValidationProvider>
                </td>
                <td style="width: 10%">
                    <ValidationProvider rules="required" v-slot="{ errors }" name="product quantity" :ref="'products.' + index + '.quantity'">
                        <input type="number"
                               min="1"
                               :max="product.warehouseId && orderStatus == 1 ? product.warehouses.find( (el) => el.id == product.warehouseId).max : 10000"
                               v-model="products[index].quantity"
                               class="form-control m-input m-input--pill m-input--air"
                               :class="{ 'is-invalid': errors.length > 0 }"
                               @change="increasePriceByQuantity(index)">

                        <div v-if="errors.length > 0" class="invalid-feedback">
                            {{ errors[0] }}
                        </div>
                    </ValidationProvider>
                </td>
                <td v-if="orderStatus == 1">
                    <ValidationProvider rules="required" v-slot="{ errors }" name="warehouse" :ref="'products.' + index + '.warehouse_id'">
                        <select v-if="availableWarehouses(index).length > 0" class="form-control m-input m-input--air m-input--pill"
                                v-model="products[index].warehouseId"
                                :class="{ 'is-invalid': errors.length > 0 }"
                                :disabled="product.warehouses.length < 1">

                            <option v-for="(warehouse, indexW) in availableWarehouses(index)" :value="warehouse.id">{{ warehouse.name }}</option>
                        </select>

                        <p v-else style="color: red">Out of stock!</p>

                        <div v-if="errors.length > 0" class="invalid-feedback">
                            {{ errors[0] }}
                        </div>
                    </ValidationProvider>

                    <ValidationProvider rules="required" v-slot="{ errors }" name="warehouse" :ref="'products.' + index">
                        <div v-if="errors.length > 0" class="invalid-feedback" style="display: inline !important;">
                            {{ errors[0] }}
                        </div>
                    </ValidationProvider>
                </td>
                <td>
                    <span>
                        <button type="button" @click="removeProduct(index)" class="btn btn-danger btn-sm">
                            <i class="la la-trash"></i>
                        </button>
                    </span>
                </td>
            </tr>

            </tbody>
        </table>
    </div>

</div>